#!/usr/bin/env python
# -*- coding: utf-8 -*-

from PyQt4.QtCore import *
from PyQt4.QtGui import *
from platform import system

from qtibia_lib import *

myDialog = None


def formOpen(dialog, layer, feature):
    global myDialog
    global mylayerid
    global myfeatureid
    myDialog = dialog
    mylayerid = layer
    myfeatureid = feature.id()

    myDialog = InstallationClass(dialog, mylayerid, feature)


class InstallationClass(QTibia_Dialog):
    def __init__(self, dialog, layerid, featureid):
        #  print "uau"
        QTibia_Dialog.__init__(self, dialog, layerid, featureid)

        self.typeSelector = dialog.findChild(QComboBox, 'installation_type')
        self.typeSelector.currentIndexChanged.connect(self.typeSelection)
        self.subForms = []
        for i in range(0, self.typeSelector.count()):
            widgetName = self.typeSelector.itemData(i)
            childWidget = dialog.findChild(QWidget, widgetName)
            self.subForms.append(childWidget)

        self.typeSelection(self.typeSelector.currentIndex())


        # fk_status fk_distributor fk_watertype fk_object_reference fk_precisionalti fk_pressurecontrol_type fk_pump_type fk_pump_operating fk_source_type fk_source_quality fk_tank_firestorage

        self.combo_fk_status               = dialog.findChild(QComboBox, "fk_status")
        self.combo_fk_distributor          = dialog.findChild(QComboBox, "fk_distributor")
        self.combo_fk_object_reference     = dialog.findChild(QComboBox, "fk_object_reference")
        self.combo_fk_precisionalti        = dialog.findChild(QComboBox, "fk_precisionalti")
        self.combo_fk_precision            = dialog.findChild(QComboBox, "fk_precision")
        self.combo_fk_watertype            = dialog.findChild(QComboBox, "fk_watertype")
        self.combo_installation_type       = dialog.findChild(QComboBox, "installation_type")
        # self.combo_fk_pressurecontrol_type = dialog.findChild(QComboBox, "fk_pressurecontrol_type")
        # self.combo_fk_pump_type            = dialog.findChild(QComboBox, "fk_pump_type")
        # self.combo_fk_pump_operating       = dialog.findChild(QComboBox, "fk_pump_operating")
        # self.combo_fk_source_type          = dialog.findChild(QComboBox, "fk_source_type")
        # self.combo_fk_source_quality       = dialog.findChild(QComboBox, "fk_source_quality")
        # self.fk_overflow                   = dialog.findChild(QComboBox, "fk_overflow")
        # self.fk_tank_firestorage           = dialog.findChild(QComboBox, "fk_tank_firestorage")
        # self.cistern1_fk_type              = dialog.findChild(QComboBox, "cistern1_fk_type")
        # self.cistern2_fk_type              = dialog.findChild(QComboBox, "cistern2_fk_type")


        self.tab_principal = dialog.findChild(QTabWidget, "tabWidget")
        if system()=='Windows':
            self.v_original_color = self.tab_principal.tabBar().tabTextColor(0)

        # Default values button

        self.gridLayout = dialog.findChild(QGridLayout, "gridLayout")

        self.ok_buttonBox = dialog.findChild(QDialogButtonBox, "buttonBox")
        m_lay = QHBoxLayout()
        # add widgets to layout
        m_lay.addWidget(self.btn_default_vals)
        m_lay.addWidget(self.ok_buttonBox)


        # add layout to grid
        self.gridLayout.addLayout(m_lay, self.gridLayout.rowCount() - 1, self.gridLayout.columnCount() - 1)

        # calls the function that sets the button visibility

            # variable holding the widgets that don't permit null values when passing the form

        self.need_fill = [self.combo_installation_type,
                          self.combo_fk_status,
                          self.combo_fk_distributor,
                          self.combo_fk_object_reference,
                          self.combo_fk_watertype]#,
                          # self.combo_fk_pressurecontrol_type,
                          # self.combo_fk_pump_type,
                          # self.combo_fk_pump_operating,
                          # self.combo_fk_source_type,
                          # self.combo_fk_source_quality,
                          # self.fk_overflow,
                          # self.fk_tank_firestorage,
                          # self.cistern1_fk_type,
                          # self.cistern2_fk_type]

        self.LineEdit_altitude      = dialog.findChild(QLineEdit, "altitude")
        self.LineEdit_altitude.editingFinished.connect(self.altitude_editingFinished)

        if(self.LineEdit_altitude.displayText() != ''):
            self.need_fill.append(self.combo_fk_precisionalti)
            self.need_fill.append(self.combo_fk_precision)

        self.btn_default_vals.clicked["bool"].connect(self.defaultButtonClicked)
        mylayerid.editingStarted.connect(self.set_btn_visibility)
        mylayerid.editingStopped.connect(self.disconnect_after_stop_edit)

        if mylayerid.isEditable():
            self.btn_default_vals.show()
            self.set_if_is_new()
        else:
            self.btn_default_vals.hide()






    def typeSelection(self, index):
        for i, widget in enumerate(self.subForms):
            widget.setVisible(i == index)


    def defaultButtonClicked(self):
        if self.combo_fk_status              .isVisible(): self.setDefValues(self.combo_fk_status              , u'Funcţional')
        if self.combo_fk_distributor         .isVisible(): self.setDefValues(self.combo_fk_distributor         , 0)
        if self.combo_fk_object_reference    .isVisible(): self.setDefValues(self.combo_fk_object_reference    , u'sol')
        if self.combo_fk_watertype           .isVisible(): self.setDefValues(self.combo_fk_watertype           , u'potabilă')
        self.f_verifica_daca_mai_am_combo_rosu()


    def altitude_editingFinished(self):
        if(self.LineEdit_altitude.displayText() != ''):
            if(self.combo_fk_precisionalti not in self.need_fill ):
                self.need_fill.append(self.combo_fk_precisionalti )
                self.need_fill.append(self.combo_fk_precision)
                self.set_if_is_new()
