#!/usr/bin/env python
# -*- coding: utf-8 -*-
#http://nathanw.net/2012/03/30/custom-qgis-feature-forms-value-binding/
#http://nathanw.net/2013/08/02/death-to-the-messagebox-using-the-qgis-messagebar/
## Import the PyQt and QGIS libraries
from PyQt4.QtCore import *
from PyQt4.QtGui import *

'''docs'''
#Astea 2 de mai jos poate-mi folosesc pt SQL..
from PyQt4.QtSql import *
from qgis.core import *
#from qgis.gui import QgisInterface, QgsMessageBar

#from PyQt4.QtNetwork import QFtp
from ftplib import FTP_TLS


#global variables to hold the dialog field
myDialog = None

def forma_statii_pompare_canal(dialog, layerid, featureid):
    global myDialog
    myDialog = dialog
    global mylayerid
    mylayerid = layerid
    global myfeatureid
    myfeatureid = featureid.id()
    global tab_principal
    global doc_table
    global uri
    uri = getConnectionInfo()
    global db
    global docsProgressBar
    docsProgressBar = dialog.findChild(QProgressBar, "docsProgressBar")
    db = setConnection(uri)
    global dbDocTable
    dbDocTable = uri.schema() + '_' + uri.table()
    tab_principal = dialog.findChild(QTabWidget, "tabPrincipal")
    doc_table = dialog.findChild(QTableView, "documentetableView")
    global adaugaButton
    adaugaButton = dialog.findChild(QPushButton, "adaugaButton")
    stergeButton = dialog.findChild(QPushButton, "stergeButton")
    global downloadeazaButton
    downloadeazaButton = dialog.findChild(QPushButton, "downloadeazaButton")

    global docsQm #sets the documents querymodel
    docsQm = QSqlQueryModel()
    #self.connect(object emitting the signal, signal signature, slot/method/function to execute)
    #conecteaza tabul principal

    dialog.connect(tab_principal,
                 SIGNAL("currentChanged(int)"),
                 click_tab)

    global idField
    idField = dialog.findChild(QLineEdit, "id")
    global idlabel
    idlabel = dialog.findChild(QLabel, "labelid")
    global docsLabel
    docsLabel = dialog.findChild(QLabel, "labelDocs")

    if len(idField.text()) > 0 and idField.text()[0] == 'n':    # daca id-ul e pe nextvalue
        idField.hide()
        idlabel.setText("<b>ID auto<b>")
        adaugaButton.hide()
        stergeButton.hide()
        downloadeazaButton.hide()
        docsProgressBar.hide()
        doc_table.hide()
    else:               #daca id'ul nu e automat
        docsLabel.hide()

    if mylayerid.isEditable():      # ascunde butoatenele adauga/sterge pt documente
        #conecteaza butoanele de adaugare si stergere doc, precum si cel de editare descriere
        dialog.connect(adaugaButton, SIGNAL("clicked(bool)"), adaugaDocsClicked)
        dialog.connect(stergeButton, SIGNAL("clicked(bool)"), stergeDocsClicked)
        dialog.connect(doc_table, SIGNAL("doubleClicked(QModelIndex)"), editare_descriere)
    else:
        stergeButton.hide()
        adaugaButton.hide()

    #conecteaza butonul de download
    dialog.connect(downloadeazaButton,
                SIGNAL("clicked(bool)"),
                downloadDocsClicked)

    buttonBox = dialog.findChild(QDialogButtonBox, "buttonBox")
    # Disconnect the signal that QGIS has wired up for the dialog to the button box.
    buttonBox.accepted.disconnect(myDialog.accept)
    # Wire up our own signals.
    buttonBox.accepted.connect(myDialog.accept)
    buttonBox.rejected.connect(myDialog.reject)

    '''docs'''



'''docs'''

def click_tab(tab_index):
    #print "Tab index", tab_index
    #if user clicked the documente tab..
    if tab_principal.tabText(tab_index) == 'Documente':
        db.open()
        #sets the documents query
        getDocumente(docsQm, uri)
        #ties the docQm to the doc_table_view
        doc_table.setModel(docsQm)

def getDocumente(docQm, uri):
    docQm.setQuery("""SELECT *
             FROM
                documente.%s
            WHERE id_master = %s
            ORDER BY id
            limit 1000;""" % (dbDocTable, myfeatureid))

def adaugaDocsClicked(self):
    print "Ai facut click pe adauga Documente"
    adaugaButton.setStyleSheet("background-color: rgba(157, 241, 0, 50);")  # arata ca e activ
    doc_list = QFileDialog.getOpenFileNames(myDialog, "Adauga Documente")
    if doc_list:    #Checks if user has selected any file
        #calls the add_db_docs and also assigns it to db_doc_list
        id_docs = adauga_docs_db(doc_list)
        #De completat
        adauga_docs_ftp(doc_list, id_docs)
        #reruns the getDocumente after the files are uploaded in order to refresh view
        getDocumente(docsQm, uri)
    adaugaButton.setStyleSheet("background-color: none")  # arata ca e inactiv

def adauga_docs_db(doc_list):
    #variable that holds the ids of the documents in the database
    id_docs = []
    query_template = ("""INSERT INTO documente.%s
                                 (nume_document,
                                 tip_document,
                                 id_master)
                            VALUES
                                 %s
                            RETURNING id;""" % (dbDocTable, '%s'))
    values_str = ", ".join(\
        ["('%s', '%s', %s)" % (QFileInfo(i).baseName() + '.' + QFileInfo(i).suffix(),
                         QFileInfo(i).suffix(),
                         myfeatureid)
                        for i in doc_list])
    query_files = query_template % values_str
    #print "db is open: ", db.isOpen()
    query = QSqlQuery(db)
    #print "db Query files: ", query_files
    if query.exec_(query_files):
        while query.next():
            id_docs.append(query.value(0))
    return id_docs

def adauga_docs_ftp(doc_list, id_docs):
    print "Adaug documente in ftp"
    ftp = connect_to_ftp()
    if ftp:    #Daca conexiunea la ftp e ok
        stor = 'STOR /home/ftp-docs/' + dbDocTable + '/%s'
        for i, doc in enumerate(doc_list):
            try:
                fileinfo = QFileInfo(doc)
                #Set the progress bar maximum to the size of each doc
                docsProgressBar.setMaximum(fileinfo.size())
                #activate the progress bar (disabled in the ui beforehand)
                docsProgressBar.setEnabled(True)
                fname = str(id_docs[i]) + '_' + fileinfo.baseName() + '.' + fileinfo.suffix()
                f = open(doc, 'rb')
                #TODO change path and maybe upstairs change to embed id_master..
                #print "numele Fisierului de stocat: ", fname
                ftp.storbinary(stor % fname, f, 8192, callback=up_filesCallback)
                #reset and disable the progress bar
                docsProgressBar.setValue(0)
                docsProgressBar.setEnabled(False)
                f.close()
            except Exception, e:
                msgBox = QMessageBox()
                msgBox.setText('Probleme cu ftp-ul: ' + str(e))
                msgBox.exec_()
                docsProgressBar.setValue(0) # reseteaza la 0 progressbarul
                #sterge din bd documentul netransferat, din pacate ramane pe ftp o bucatica
                sterge_db_docs([id_docs[i]])
        try:
            ftp.quit()
        except Exception, e:
            print e
    else:   # daca conexiunea cu ftp-ul nu merge
        sterge_db_docs(id_docs)  # sterge-le si din baza de date

def up_filesCallback(tb_param):
    docsProgressBar.setValue(docsProgressBar.value() + 8192)


def connect_to_ftp():
    ftp = None
    try:
        ftp = FTP_TLS('gisftp',timeout=5)  # connect to host, default port
        ftp_dir = '/home/ftp-docs/' + dbDocTable
        ftp.login(uri.username(), uri.password())
        ftp.prot_p()               # switch to secure data connection
        #print ftp.retrlines('LIST')
        ftp.cwd(ftp_dir) # change directory to ftp_dir
    except Exception, e:
        msgBox = QMessageBox()
        msgBox.setText('Probleme cu ftp-ul: ' + str(e))
        msgBox.exec_()
    return ftp

def stergeDocsClicked():
    #lista id_docs contine id-ul din bd; lista nume_docs tine numele documentelor selectate
    (id_docs, nume_docs) = documenteSelectate()
    if id_docs:  # daca sunt documente selectate
        msgBox = QMessageBox()
        msgBox.setText("Sigur vrei sa stergi?")
        msgBox.addButton(QPushButton('Nu'), QMessageBox.NoRole)
        msgBox.addButton(QPushButton('Da'), QMessageBox.YesRole)
        msgBox.setDefaultButton(QPushButton('Nu'))
        rasp = msgBox.exec_()
        if rasp:
            #run the delete from ftp method
            try:
                del_ftp_docs(id_docs, nume_docs)  #TODO, in case ftp files were not deleted
                #run the delete docs from db method
            except Exception, e:
                print e
                id_docs = []
            sterge_db_docs(id_docs)
            #reruns the getDocumente after the files are deleted in order to refresh view
            getDocumente(docsQm, uri)
    else:
        print "Nu e selectat niciun document"

def del_ftp_docs(id_docs, nume_docs):
    ftp = connect_to_ftp()
    for i, doc in enumerate(nume_docs):
        print "(i, doc)", (i, doc)
        ftp.delete(str(id_docs[i]) + '_' + doc)

def sterge_db_docs(id_docs):
    print "Delete from db has been run"
    query_template = ("""delete from documente.%s
                          where id in (%s);""" % (dbDocTable,'%s'))

    values_str = ", ".join([str(i) for i in id_docs])
    query_files = query_template % values_str
    #print "Query files", query_files
    query = QSqlQuery(db)
    if query.exec_(query_files):
        print 'deleted', id_docs

#returneaza listele cu numele documentelor precum si cea cu id-ul acestora
def documenteSelectate():
    row_list = doc_table.selectionModel().selectedRows()
    document_list =[]
    db_documents_id = []
    if row_list:       #if row_list is not empty
        for document in row_list:
            #the next 2 variables hold the id and name of the selected docs from the querymodel
            rw_docId = docsQm.data(docsQm.index(document.row(), 0))  # prima coloana e id-ul
            rw_docName = docsQm.data(docsQm.index(document.row(),1))  # a 2-a coloana e numele, deci 1
            #append to the corresponding list
            db_documents_id.append(rw_docId)
            document_list.append(rw_docName)
    return (db_documents_id, document_list)


def downloadDocsClicked():
    print "Ai apasat pe download documente"
    downloadeazaButton.setStyleSheet("background-color: rgba(157, 241, 0, 50);")  # arata ca e activ
    doc_table.selectionModel().selectedRows()  # de sters
    (id_docs, nume_docs) = documenteSelectate()
    if id_docs:
        dir_ales = QFileDialog.getExistingDirectory(myDialog, "Alege director")
        if dir_ales :
            ftp = connect_to_ftp()
            for i in range(0, len(id_docs)):
                fname = str(id_docs[i]) + '_' + nume_docs[i]
                fsize = ftp.size(fname)
                #set the max size of progressbar
                docsProgressBar.setMaximum(fsize)
                docsProgressBar.setEnabled(True)
                myDialog.out_file = open(dir_ales + '/' + fname, 'wb')
                ftp.retrbinary("RETR " + fname, callback=down_filesCallback)

                myDialog.out_file.close()

                docsProgressBar.setValue(0)
                docsProgressBar.setEnabled(False)
            #quit the ftp connection
            ftp.quit()
    downloadeazaButton.setStyleSheet("background-color: none);") # arata ca e inactiv

def down_filesCallback(block_data):
    myDialog.out_file.write(block_data)
    #update the progress bar
    docsProgressBar.setValue(docsProgressBar.value() + 8192)

def setConnection(uri):
    db = QSqlDatabase.addDatabase("QPSQL"); #Name of the driver -- doesn't change
    db.setHostName(uri.host())
    db.setDatabaseName(uri.database())
    db.setUserName(uri.username())
    db.setPassword(uri.password())
    #db.open()
    return db

def getConnectionInfo():
    uri = QgsDataSourceURI(mylayerid.dataProvider().dataSourceUri())
    connInfo = QgsDataSourceURI( mylayerid.dataProvider().dataSourceUri()).connectionInfo()
    if not uri.password():
        #print "Pentru cazul in care parola si userul nu sunt salvate in proiect"
        #Ia userul si parola din alta parte
        (success, user, passwd ) = QgsCredentials.instance().get(connInfo, None, None)
        if success:
            QgsCredentials.instance().put(connInfo, user, passwd)
            uri.setPassword(passwd)
            uri.setUsername(user)
    #print "Informatii conexiune"
    #print uri.host(), uri.database(), int(uri.port()), uri.username(), uri.password(), uri.schema(), uri.table()
    return uri

def editare_descriere(indexul):
    if indexul.column() == 3: # daca a apasat pe descriere
        print "Ai apasat pe campul descriere pe randul", indexul.row()
        def showDialog(myDialog):
            text, ok = QInputDialog.getText(myDialog, u'Descriere Document',
                u'Introdu Descrierea:')
            if ok:
                (id_docs, nume_docs) = documenteSelectate() #ca sa
                desc_inp = unicode(text)
                query = QSqlQuery(db)
                query.exec_("""UPDATE documente.%s SET descriere = '%s'
                    WHERE id = %d;""" % (dbDocTable, desc_inp, id_docs[0]))
                #print id_docs
                #reruns the getDocumente after the description is edited in order to refresh table view
                getDocumente(docsQm, uri)
        showDialog(myDialog)

'''docs'''
